Index: /trunk/sources/LibSVM/Solver.cs
===================================================================
--- /trunk/sources/LibSVM/Solver.cs	(revision 2414)
+++ /trunk/sources/LibSVM/Solver.cs	(revision 2415)
@@ -2318,20 +2137,8 @@
 
             SvmType svm_type = param.SvmType;
-            if (svm_type != SvmType.C_SVC &&
-               svm_type != SvmType.NU_SVC &&
-               svm_type != SvmType.ONE_CLASS &&
-               svm_type != SvmType.EPSILON_SVR &&
-               svm_type != SvmType.NU_SVR)
-                return "unknown svm type";
 
             // kernel_type, degree
 
             KernelType kernel_type = param.KernelType;
-            if (kernel_type != KernelType.LINEAR &&
-               kernel_type != KernelType.POLY &&
-               kernel_type != KernelType.RBF &&
-               kernel_type != KernelType.SIGMOID &&
-               kernel_type != KernelType.PRECOMPUTED)
-                return "unknown kernel type";
 
             if (param.Degree < 0)
@@ -2345,4 +2152,7 @@
             if (param.EPS <= 0)
                 return "eps <= 0";
+
+            if (param.Gamma == 0)
+                param.Gamma = 1.0 / prob.MaxIndex;
 
             if (svm_type == SvmType.C_SVC ||
@@ -2362,5 +2172,6 @@
                     return "p < 0";
 
-            if (param.Probability && svm_type == SvmType.ONE_CLASS)
+            if (param.Probability &&
+               svm_type == SvmType.ONE_CLASS)
                 return "one-class SVM probability output not supported yet";
 
@@ -2370,8 +2181,8 @@
             {
                 int l = prob.Count;
-                int max_nr_class = 16;
+                int Max_nr_class = 16;
                 int nr_class = 0;
-                int[] label = new int[max_nr_class];
-                int[] count = new int[max_nr_class];
+                int[] label = new int[Max_nr_class];
+                int[] count = new int[Max_nr_class];
 
                 int i;
@@ -2389,12 +2200,12 @@
                     if (j == nr_class)
                     {
-                        if (nr_class == max_nr_class)
-                        {
-                            max_nr_class *= 2;
-                            int[] new_data = new int[max_nr_class];
+                        if (nr_class == Max_nr_class)
+                        {
+                            Max_nr_class *= 2;
+                            int[] new_data = new int[Max_nr_class];
                             Array.Copy(label, 0, new_data, 0, label.Length);
                             label = new_data;
 
-                            new_data = new int[max_nr_class];
+                            new_data = new int[Max_nr_class];
                             Array.Copy(count, 0, new_data, 0, count.Length);
                             count = new_data;
@@ -2432,4 +2243,3 @@
         }
     }
-
 }
Index: /trunk/sources/LibSVM/TemporaryCulture.cs
===================================================================
--- /trunk/sources/LibSVM/TemporaryCulture.cs	(revision 2415)
+++ /trunk/sources/LibSVM/TemporaryCulture.cs	(revision 2415)
@@ -0,0 +1,25 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Globalization;
+using System.Threading;
+
+namespace SVM
+{
+    internal static class TemporaryCulture
+    {
+        private static CultureInfo _culture;
+
+        public static void Start()
+        {
+            _culture = Thread.CurrentThread.CurrentCulture;
+            Thread.CurrentThread.CurrentCulture = CultureInfo.InvariantCulture;
+        }
+
+        public static void Stop()
+        {
+            Thread.CurrentThread.CurrentCulture = _culture;
+        }
+    }
+}
Index: /trunk/sources/LibSVM/Training.cs
===================================================================
--- /trunk/sources/LibSVM/Training.cs	(revision 2414)
+++ /trunk/sources/LibSVM/Training.cs	(revision 2415)
@@ -23,49 +23,52 @@
 namespace SVM
 {
-    /// <remarks>
+    /// <summary>
     /// Class containing the routines to train SVM models.
-    /// </remarks>
+    /// </summary>
     public static class Training
     {
+        /// <summary>
+        /// Whether the system will output information to the console during the training process.
+        /// </summary>
+        public static bool IsVerbose
+        {
+            get
+            {
+                return Procedures.IsVerbose;
+            }
+            set
+            {
+                Procedures.IsVerbose = value;
+            }
+        }
+
         private static double doCrossValidation(Problem problem, Parameter parameters, int nr_fold)
         {
             int i;
             double[] target = new double[problem.Count];
-            Dictionary<int, double>[] confidence = new Dictionary<int, double>[problem.Count];
-            Procedures.svm_cross_validation(problem, parameters, nr_fold, target, confidence);
-            if (parameters.Probability)
-            {
-                List<RankPair> ranks = new List<RankPair>();
-                for (i = 0; i < target.Length; i++)
-                    ranks.Add(new RankPair(confidence[i][1], problem.Y[i]));
-                PerformanceEvaluator eval = new PerformanceEvaluator(ranks);
-                return eval.AuC*eval.AP;
+            Procedures.svm_cross_validation(problem, parameters, nr_fold, target);
+            int total_correct = 0;
+            double total_error = 0;
+            double sumv = 0, sumy = 0, sumvv = 0, sumyy = 0, sumvy = 0;
+            if (parameters.SvmType == SvmType.EPSILON_SVR || parameters.SvmType == SvmType.NU_SVR)
+            {
+                for (i = 0; i < problem.Count; i++)
+                {
+                    double y = problem.Y[i];
+                    double v = target[i];
+                    total_error += (v - y) * (v - y);
+                    sumv += v;
+                    sumy += y;
+                    sumvv += v * v;
+                    sumyy += y * y;
+                    sumvy += v * y;
+                }
+                return(problem.Count * sumvy - sumv * sumy) / (Math.Sqrt(problem.Count * sumvv - sumv * sumv) * Math.Sqrt(problem.Count * sumyy - sumy * sumy));
             }
             else
-            {
-                int total_correct = 0;
-                double total_error = 0;
-                double sumv = 0, sumy = 0, sumvv = 0, sumyy = 0, sumvy = 0;
-                if (parameters.SvmType == SvmType.EPSILON_SVR || parameters.SvmType == SvmType.NU_SVR)
-                {
-                    for (i = 0; i < problem.Count; i++)
-                    {
-                        double y = problem.Y[i];
-                        double v = target[i];
-                        total_error += (v - y) * (v - y);
-                        sumv += v;
-                        sumy += y;
-                        sumvv += v * v;
-                        sumyy += y * y;
-                        sumvy += v * y;
-                    }
-                }
-                else
-                    for (i = 0; i < problem.Count; i++)
-                        if (target[i] == problem.Y[i])
-                            ++total_correct;
-                return (double)total_correct / problem.Count;
-            }
-
+                for (i = 0; i < problem.Count; i++)
+                    if (target[i] == problem.Y[i])
+                        ++total_correct;
+            return (double)total_correct / problem.Count;
         }
         /// <summary>
@@ -96,6 +99,8 @@
         public static double PerformCrossValidation(Problem problem, Parameter parameters, int nrfold)
         {
-            Procedures.svm_check_parameter(problem, parameters);
-            return doCrossValidation(problem, parameters, nrfold);
+            string error = Procedures.svm_check_parameter(problem, parameters);
+            if (error == null)
+                return doCrossValidation(problem, parameters, nrfold);
+            else throw new Exception(error);
         }
 
@@ -108,7 +113,9 @@
         public static Model Train(Problem problem, Parameter parameters)
         {
-            Procedures.svm_check_parameter(problem, parameters);
-
-            return Procedures.svm_train(problem, parameters);
+            string error = Procedures.svm_check_parameter(problem, parameters);
+
+            if (error == null)
+                return Procedures.svm_train(problem, parameters);
+            else throw new Exception(error);
         }
 
@@ -190,18 +197,5 @@
 
                     case 'w':
-                        ++parameters.WeightCount;
-                        {
-                            int[] old = parameters.WeightLabels;
-                            parameters.WeightLabels = new int[parameters.WeightCount];
-                            Array.Copy(old, 0, parameters.WeightLabels, 0, parameters.WeightCount - 1);
-                        }
-                        {
-                            double[] old = parameters.Weights;
-                            parameters.Weights = new double[parameters.WeightCount];
-                            Array.Copy(old, 0, parameters.Weights, 0, parameters.WeightCount - 1);
-                        }
-
-                        parameters.WeightLabels[parameters.WeightCount - 1] = int.Parse(args[i - 1].Substring(2));
-                        parameters.Weights[parameters.WeightCount - 1] = double.Parse(args[i]);
+                        parameters.Weights[int.Parse(args[i - 1].Substring(2))] = double.Parse(args[1]);
                         break;
 
